var styles = `
html {
    overflow: scroll;
    overflow-x: hidden;
}
::-webkit-scrollbar {
    width: 0;
    background: transparent;
}
.slider-item.nkc-selected{
    /* padding: 0.5rem !important; */
    /* border: inset 1px solid white; */
    /* padding-bottom: 0.25rem; */
    z-index: 2 !important;
}

/*:not(.nkc-selected) .boxart-container{
    opacity: 0.6;
    transition: opacity 50ms;
}*/

.title-card .slider-refocus:focus-visible {
    outline: none !important;
}

.searchTab.nkc-selected{
    border: 2px solid white;
}


:not(.nkc-selected-hidden).nkc-selected .boxart-container {
    border: 2px solid white;
    opacity: 1;
    transition: border 50ms;

    /* box-shadow: 2px 2px 2px 2px rgba(255,255,255,1); */

}

.nkc-selected-hidden .boxart-container{
    border: none !important;
    opacity: 1;
    /* box-shadow: 2px 2px 2px 2px rgba(255,255,255,1); */

}

.choose-profile .nkc-selected{
    border: inset;

}

.tabbed-primary-navigation li.nkc-selected{
    border: 2px solid white;
    padding: 2px;
}

#nkc-menu{
    background-color:black;
    position: absolute;
    top: 0;
    right: 0;
    z-index: 99999;
}

.cursor-none{
    cursor: none !important;
}

.pointer-none{
    pointer-events: none !important;
}

/* .playLink  */
button.jawbone-selected {
    background-color: #e50914 !important;
    color: white !important;
}

.jawbone-selected {
    background-color: #e50914 !important;
    color: white !important;
}

li.jawbone-selected {
    border: 1px solid;
}

.watch-video--player-view button.nkc-selected {
    background-color: #e50914 !important;
    color: white !important;
}

.nkc-warning{
    /* background-color: #e50914 !important; */
    /* color: #e50914 !important;
    position: absolute;
    bottom: 0;
    padding-top: 1rem; */
}

.SeamlessControls--container button.nkc-selected {
    border: 4px solid red;
}

.billboard-links button.nkc-selected, .billboard-links .nkc-selected button {
    background-color: #e50914 !important;
    color: white !important;
}
`

function JRLog(message) {
    let jsonObject = { Key: 'jrlogging', Value: message };
    try {
        window.chrome.webview.postMessage(jsonObject);
    } catch (error) { console.log(message); }
}

var getNextSibling = function (elem, selector) {

	// Get the next sibling element
	var sibling = elem.nextElementSibling;

	// If there's no selector, return the first sibling
	if (!selector) return sibling;

	// If the sibling matches our selector, use it
	// If not, jump to the next sibling and continue the loop
	while (sibling) {
		if (sibling.matches(selector)) return sibling;
		sibling = sibling.nextElementSibling
	}

};

var getPreviousSibling = function (elem, selector) {

	// Get the next sibling element
	var sibling = elem.previousElementSibling;

	// If there's no selector, return the first sibling
	if (!selector) return sibling;

	// If the sibling matches our selector, use it
	// If not, jump to the next sibling and continue the loop
	while (sibling) {
		if (sibling.matches(selector)) return sibling;
		sibling = sibling.previousElementSibling;
	}

};
class WatchPage {
    constructor() {
    }
    up() { }
    down() { }
    next() {
    }
    previous() {
    }
    select() {
        const controls = document.querySelector('.watch-video--player-view');
        const skipButton = controls?.querySelector('[data-uia="player-skip-intro"].nkc-selected, [data-uia="player-skip-recap"].nkc-selected');
        if (skipButton) {
            skipButton?.click();
        }

        if (this.seenSeamless)
        {
            const button = this.getSeamlessButton();
            button?.click();
        }
    }

    handleMutation(mutation) {
        const target = mutation.target
        const skipLink = target?.querySelector('[data-uia="player-skip-intro"], [data-uia="player-skip-recap"]');
        if (skipLink && !this.seenCreditsButton) {
            this.seenCreditsButton = true;

            if (JR_autoSkipCredits) {
                skipLink.click();
            }
            else {
                skipLink.classList.add('nkc-selected');
            }
        }
        else if (this.seenCreditsButton && !document.querySelector('[data-uia="player-skip-intro"], [data-uia="player-skip-recap"]'))
        {
            this.seenCreditsButton = false;
        }
        const seamlessControls = target?.querySelector('.SeamlessControls--container');
        if (seamlessControls) {
            this.seenSeamless = true;
        }
        else if (this.seenSeamless && !document.querySelector('.SeamlessControls--container'))
        {
            this.seenSeamless = false;
        }
    }

    dispatchKey(keyCode, isKeyDown=true) {
        let event = new KeyboardEvent(isKeyDown ? 'keydown' : 'keyup', {
            key: String.fromCharCode(keyCode),
            keyCode: keyCode, bubbles: true, cancelable: true, view: window
        });
        document.querySelector('.watch-video--player-view > [data-uia="player"]')?.dispatchEvent(event);
    }

    handleKeyPress(event) {
        switch (event.key) {
            case 'MediaPlayPause':
                this.dispatchKey(32);
                break;
            case 'MediaStop':
                window.history.back();
                break;
            case 'f':
            case 'F':
                if (event.ctrlKey && event.shiftKey)
                    this.dispatchKey(39);
                break;
            case 'b':
            case 'B':
                if (event.ctrlKey && event.shiftKey)
                    this.dispatchKey(37);
                break;
            /*case 'AudioVolumeMute':
                this.dispatchKey(77);
                event.preventDefault();
                event.stopPropagation();
                event.cancelBubble = true;
                break;*/
        }
    }

    handleMessage(event) {
        switch (event.data) {
            case 'MCC_PLAY':
                this.dispatchKey(32);
                break;
            case 'MCC_STOP':
                window.history.back();
                break;
            case 'MCC_FAST_FORWARD':
                this.dispatchKey(39);
                break;
            case 'MCC_REWIND':
                this.dispatchKey(37);
                break;
        }
    }

    priorityKeyEvent(event) {
        try {
            switch (event.key) {
                case 'Enter':
                    // interactive content is up, don't intercept controls
                    if (document.querySelector('.BranchingInteractiveScene--wrapper'))
                        return;

                    // no selected element
                    if (!document.querySelector('.nkc-selected') && !this.seenSeamless)
                        return;

                    event.preventDefault();
                    event.cancelBubble = true;
                    this.select();
                    break;
                case 'ArrowRight':
                    if (this.seenSeamless)
                    {
                        this.next();
                        event.preventDefault();
                        event.cancelBubble = true;
                    }
                    break;
                case 'ArrowLeft':
                    if (this.seenSeamless)
                    {
                        this.previous();
                        event.preventDefault();
                        event.cancelBubble = true;
                    }
                    break;
                case 'f':
                case 'F':
                case 'b':
                case 'B':
                    if (event.ctrlKey && event.shiftKey)
                    {
                        this.handleKeyPress(event);
                        event.preventDefault();
                        event.cancelBubble = true;
                    }
                    break;
            }
        }
        catch (error) {
            console.log(error);
        }
    }

    getSeamlessButton()
    {
        var button = document.querySelector('.SeamlessControls--container button.nkc-selected');
        if (!button)
            button = document.querySelector('.SeamlessControls--container button:last-of-type');

        return button;
    }
}
class JawBoneNav {
    constructor() {
        const play = document.querySelector('.buttonControls--container a[data-uia="play-button"] button')
        if (play) {
            play.classList.add('jawbone-selected');
            this.seenPlayButton = true;
        }
    }
    handleMutation(mutation) {
        if (!this.seenPlayButton)
        {
            const play = document.querySelector('.buttonControls--container a[data-uia="play-button"] button')
            if (play) {
                play.classList.add('jawbone-selected');
                this.seenPlayButton = true;
            }
        }
    }
    up() {
    }
    down() {
        if (document.querySelector('.dropdown-toggle')) {
            currentPage = new SeasonSelect();
        } else if (document.querySelector('.episodeSelector')) {
            currentPage = new EpisodeSelect();
        }
    }
    next() {
        return; // TODO: Enable when we can handle the rating popup
        const buttons = document.querySelectorAll('.buttonControls--container button');
        for (let i = 0; i < buttons.length; i++) {
            const button = buttons[i];
            if (button.classList.contains('jawbone-selected')) {
                if (i === buttons.length - 1)
                    return;
                button.classList.remove('jawbone-selected');
                buttons[i + 1].classList.add('jawbone-selected');
                break;
            }
        }
    }
    previous() {
        return; // TODO: Enable when we can handle the rating popup
        const buttons = document.querySelectorAll('.buttonControls--container button');
        for (let i = buttons.length - 1; i > 0; i--) {
            const button = buttons[i];
            if (button.classList.contains('jawbone-selected')) {
                if (i === 0)
                    return;
                button.classList.remove('jawbone-selected');
                buttons[i - 1].classList.add('jawbone-selected');
                break;
            }
        }
    }
    select() {
        const currentSelected = document.querySelector('.jawbone-selected');
        if (currentSelected instanceof HTMLButtonElement) {
            currentSelected.click();
        }
        if (currentSelected instanceof HTMLLIElement) {
            console.log(`currentSelected${currentSelected}`, currentSelected);
            // body.classList.remove('pointer-none');
        }
    }
}
class SeasonSelect {
    constructor() {
        document.querySelector('.jawbone-selected')?.classList.remove('jawbone-selected');
        document.querySelector('.dropdown-toggle')?.classList.add('jawbone-selected');
    }
    up() {
        const listElements = document.querySelectorAll('ul[data-uia="dropdown-menu"] li');
        if (!listElements.length) {
            document.querySelector('.jawbone-selected')?.classList.remove('jawbone-selected');
            window.scrollTo(0, 0);
            currentPage = new JawBoneNav();
            return;
        }
        for (let i = listElements.length - 1; i > 0; i--) {
            const li = listElements[i];
            if (li.classList.contains('jawbone-selected')) {
                if (i === 0)
                    return;
                li.classList.remove('jawbone-selected');
                listElements[i - 1].classList.add('jawbone-selected');
                break;
            }
        }
    }
    ;
    down() {
        if (document.querySelector('ul[data-uia="dropdown-menu"]'))
        {
            const listElements = document.querySelectorAll('ul[data-uia="dropdown-menu"] li');
            for (let i = 0; i < listElements.length; i++) {
                const li = listElements[i];
                if (li.classList.contains('jawbone-selected')) {
                    if (i === listElements.length - 1)
                        return;
                    li.classList.remove('jawbone-selected');
                    listElements[i + 1].classList.add('jawbone-selected');
                    break;
                }
            }
        } else {
            currentPage = new EpisodeSelect();
        }
    }
    ;
    next() {
    }
    ;
    previous() {
    }
    ;
    select() {
        const dropDownSelected = document.querySelector('.dropdown-toggle.jawbone-selected');
        if (dropDownSelected) {
            dropDownSelected.click();
            document.querySelector('ul[data-uia="dropdown-menu"] li')?.classList.add('jawbone-selected');
        }
        else {
            const observer = new MutationObserver((mutations) => {
                setTimeout(() => {
                    currentPage = new EpisodeSelect();
                    observer.disconnect();
                }, 250);
            });
            observer.observe(document.querySelector('.episodeSelector-container'), { subtree: true, childList: true });
            document.querySelector('li.jawbone-selected div.episodeSelector--option')?.click();
        }
    }
    ;
}
class EpisodeSelect {
    constructor() {
        document.querySelector('.jawbone-selected')?.classList.remove('jawbone-selected');
        document.querySelector('.episodeSelector-container')?.firstChild?.classList.add('jawbone-selected');
        document.querySelector('.section-divider.collapsed button')?.click();
    }
    up() {
        const currentSelected = document.querySelector('.jawbone-selected');
        const previousSibling = currentSelected?.previousSibling;
        if (previousSibling?.classList.contains('episode-item')) {
            currentSelected?.classList.remove('jawbone-selected');
            previousSibling?.classList.add('jawbone-selected');
        }
        else {
            document.querySelector('.jawbone-selected')?.classList.remove('jawbone-selected');
            currentPage = new SeasonSelect;
        }
        if (document.querySelector('.jawbone-selected'))
            scrollElementIntoView(document.querySelector('.jawbone-selected'));
    }
    down() {
        const currentEpisode = document.querySelector('.jawbone-selected');
        const nextSibling = currentEpisode?.nextSibling;
        if (nextSibling?.classList.contains('episode-item')) {
            currentEpisode?.classList.remove('jawbone-selected');
            nextSibling?.classList.add('jawbone-selected');
        }
        ;
        if (document.querySelector('.jawbone-selected'))
            scrollElementIntoView(document.querySelector('.jawbone-selected'));
    }
    ;
    next() {
    }
    ;
    previous() {
    }
    ;
    select() {
        document.querySelector('.episode-item.jawbone-selected')?.click();
    }
    ;
}
class ProfilePage {
    constructor() { }
    get listElement() {
        return document.querySelector('ul');
    }
    selectFirst() {
        const firstElement = this.listElement?.querySelector('a')?.closest('li')?.classList.add('nkc-selected');
    }
    selectLast() {
        const allLinks = this.listElement?.querySelectorAll('a');
        if (allLinks) {
            const lastElement = allLinks[allLinks.length - 1];
            lastElement.closest('li')?.classList.add('nkc-selected');
        }
    }
    next() {
        const currentSelected = this.listElement?.querySelector('.nkc-selected');
        const next = currentSelected?.nextSibling;
        currentSelected?.classList.remove('nkc-selected');
        if (next) {
            next.classList.add('nkc-selected');
        }
        else {
            this.selectFirst();
        }
    }
    previous() {
        const currentSelected = this.listElement?.querySelector('.nkc-selected');
        const previous = currentSelected?.previousSibling;
        currentSelected?.classList.remove('nkc-selected');
        if (previous) {
            previous.classList.add('nkc-selected');
        }
        else {
            this.selectLast();
        }
    }
    down() {
    }
    up() {
    }
    select() {
        const currentSelected = this.listElement?.querySelector('.nkc-selected a');
        currentSelected?.click();
    }
    clearSelections() {
    }
}
class BrowsePage {
    constructor() {
    }
    selectFirst() {
        if (!document.querySelector('.nkc-selected')) {
            const firstItem = document.querySelector('.slider-item.slider-item-0');
            firstItem.classList.add('nkc-selected');
        }
    }
    async next() {
        if (stateManager.pauseObserver) {
            return;
        }

        const currentSelected = document.querySelector('.nkc-selected');
        let next = currentSelected?.nextSibling;
        if (next) {
            if (next.getBoundingClientRect().x + next.offsetWidth > window.innerWidth) {
                console.log("Scrolling selection")
                stateManager.pauseObserver = true;
                const slider = next.closest('.slider');
                currentSelected?.classList.remove('nkc-selected');
                const observer = new MutationObserver(async (mutations) => {
                    if (mutations[0].target?.classList.contains('animating')) {
                        return;
                    }
                    console.log("Scrolling complete")
                    setTimeout(() => {
                        slider.querySelector(':not(.nkc-selected).slider-item-1')?.classList.add('nkc-selected');
                        stateManager.pauseObserver = false;
                        observer.disconnect();
                    }, 150);
                });
                observer.observe(slider, { subtree: true, childList: true });
                slider?.querySelector('.handle.handleNext.active')?.click();
            }
            else {
                stateManager.pauseObserver = true;
                currentSelected?.classList.remove('nkc-selected');
                next.classList.add('nkc-selected');
                stateManager.pauseObserver = false;
            }
        }
        else {
            this.selectFirst();
        }
    }
    previous() {
        if (stateManager.pauseObserver) {
            return;
        }

        const currentSelected = document.querySelector('.nkc-selected');
        currentSelected?.closest('.rowContainer')?.querySelector('.jawBoneContent button.close-button')?.click();
        const previous = currentSelected?.previousSibling;
        if (previous) {
            if (previous.getBoundingClientRect().x <= 0) {
                const slider = previous.closest('.slider');
                stateManager.pauseObserver = true;
                currentSelected?.classList.remove('nkc-selected');
                const observer = new MutationObserver((mutations) => {
                    if (mutations[0].target?.classList.contains('animating')) {
                        return;
                    }
                    setTimeout(() => {
                        let items = (Array.from(slider.querySelectorAll('.slider-item')));
                        items = items.filter(item => {
                            const regex = new RegExp(/(slider-item-[0-9])/);
                            return regex.test(item.classList.value);
                        });
                        const lastItem = items[items.length - 2];
                        lastItem.classList.add('nkc-selected');
                        observer.disconnect();
                        stateManager.pauseObserver = false;
                    }, 100);
                });
                observer.observe(slider, { subtree: true, childList: true });
                slider?.querySelector('.handle.handlePrev.active')?.click();
            }
            else {
                stateManager.pauseObserver = true;
                currentSelected?.classList.remove('nkc-selected');
                previous.classList.add('nkc-selected');
                stateManager.pauseObserver = false;
            }
        }
        else {
        }
    }
    down() {
        let currentSelected = document.querySelector('.nkc-selected');
        let slider = currentSelected.closest('.slider');
        const sliders = Array.from(document.querySelectorAll('.slider'));
        let nextIndex = sliders.findIndex((element) => element === slider) + 1;
        if (nextIndex > sliders.length - 1)
            return;
        let itemIndex = 0;
        [...currentSelected.classList].forEach(value => {
            if (value.includes('slider-item-')) {
                itemIndex = parseInt(value.substring('slider-item-'.length));
            }
        });
        currentSelected.classList.remove('nkc-selected');
        const x = currentSelected.getBoundingClientRect().x;
        slider = sliders[nextIndex];
        if (slider.getBoundingClientRect().top + slider.getBoundingClientRect().height > window.innerHeight) {
            slider?.scrollIntoView({ block: "center" });
        }
        else if (nextIndex === 0) {
            slider?.scrollIntoView({ block: "center" });
        }
        const y = slider.getBoundingClientRect().top;
        // body.classList.remove('pointer-none');
        const posElements = document.elementsFromPoint(x, y);
        let nextSelected = posElements.find(element => element.classList.contains('slider-item'));
        if (!nextSelected)
            nextSelected = slider.querySelector(`.slider-item-${0}`);
        if (nextSelected.getBoundingClientRect().x < 0)
            nextSelected = slider.querySelector(`.slider-item-${1}`);
        nextSelected.classList.add('nkc-selected');
        // body.classList.add('pointer-none');
    }
    up() {
        let currentSelected = document.querySelector('.nkc-selected');
        document.querySelector('.jawBoneContent button.close-button')?.click();
        let slider = currentSelected.closest('.slider');
        const sliders = Array.from(document.querySelectorAll('.slider'));
        let nextIndex = sliders.findIndex((element) => element === slider) - 1;
        if (nextIndex < 0) {
            window.scrollTo(0, 0);
            if (document.querySelector('.billboard-row .billboard .billboard-links'))
            {
                currentPage = new BrowsePageBillboard();
                currentPage?.selectFirst();
            } else
                currentPage = new BrowsePageNavigation();
            return;
        }
        let itemIndex = 0;
        [...currentSelected.classList].forEach(value => {
            if (value.includes('slider-item-')) {
                itemIndex = parseInt(value.substring('slider-item-'.length));
            }
        });
        currentSelected.classList.remove('nkc-selected');
        const x = currentSelected.getBoundingClientRect().x;
        slider = sliders[nextIndex];
        if (slider.getBoundingClientRect().top < 0
            || nextIndex === 0) {
            slider?.scrollIntoView({ block: "center" });
        }
        const y = slider.getBoundingClientRect().top;
        // body.classList.remove('pointer-none');
        const posElements = document.elementsFromPoint(x, y);
        let nextSelected = posElements.find(element => element.classList.contains('slider-item'));
        if (!nextSelected)
            nextSelected = slider.querySelector(`.slider-item-${0}`);
        if (nextSelected.getBoundingClientRect().x < 0)
            nextSelected = slider.querySelector(`.slider-item-${1}`);
        nextSelected.classList.add('nkc-selected');
        // body.classList.add('pointer-none');
    }
    async select() {
        if (document.querySelector('.nkc-selected .title-card-tall-panel'))
        {
            // this is a bit of a hack, but there is a bug that prevents opening the panel otherwise
            const link = document.querySelector('.nkc-selected a')
            const regex = /watch\/(\d+)/;
            const found = link.href.match(regex);
            window.location.href = `https://www.netflix.com/title/${found[1]}`;
            setCurrentPage();
        } else {
            const jawBone = document.querySelector('.nkc-selected .bob-jawbone-chevron');
            jawBone?.click();
            const currentSelected = document.querySelector('.nkc-selected');
            const link = document.querySelector('.nkc-selected a');
            setCurrentPage();
        }
    }
    clearSelections() {
    }
}
const profilePage = new ProfilePage();
let currentPage;
function scrollElementIntoView(element) {
    if (element.getBoundingClientRect().top > window.innerHeight) {
        element.scrollIntoView({ block: "center" });
    }
    if (element.getBoundingClientRect().top < 0) {
        element.scrollIntoView({ block: "center" });
    }
}
function setCurrentPage() {
    if (location.href.includes('/title/') ||
        location.href.includes('?jbv=')) {
        currentPage = new JawBoneNav();
        return;
    }
    if (document.querySelector('li.profile')) {
        currentPage = profilePage;
        profilePage.selectFirst();
        return;
    }
    if (window.location.href.includes('watch/')) {
        currentPage = new WatchPage();
    }
    if (document.querySelector('.slider-item')) {
        if (document.querySelector('.billboard .billboard-links .nkc-selected'))
            currentPage = new BrowsePageBillboard();
        else
            currentPage = new BrowsePage();
    }
}
class BrowsePageNavigation {
    constructor() {
        this._listElement = document.querySelector('ul.tabbed-primary-navigation');
        document.querySelector('.nkc-selected')?.classList.remove('nkc-selected');
        this._listElement.querySelector('li.navigation-tab')?.classList.add('nkc-selected');
    }
    up() {
    }
    down() {
        document.querySelector('.nkc-selected')?.classList.remove('nkc-selected');
        if (document.querySelector('.billboard-row .billboard .billboard-links'))
            currentPage = new BrowsePageBillboard();
        else {
            currentPage = new BrowsePage();
        }
        currentPage?.selectFirst();
    }
    next() {
        const currentSelected = this._listElement?.querySelector('.nkc-selected');
        const next = currentSelected?.nextSibling;
        if (next) {
            currentSelected?.classList.remove('nkc-selected');
            next.classList.add('nkc-selected');
        }
    }
    previous() {
        const currentSelected = this._listElement?.querySelector('.nkc-selected');
        const next = currentSelected?.previousSibling;
        if (!next.classList.contains('navigation-tab'))
            return;
        currentSelected?.classList.remove('nkc-selected');
        next.classList.add('nkc-selected');
    }
    select() {
        document.querySelector('.nkc-selected a')?.click();
    }
}
class BrowsePageBillboard {
    constructor() {
        this._buttonContainer = document.querySelector('.billboard-row .billboard .billboard-links');
    }
    selectFirst() {
        document.querySelector('.nkc-selected')?.classList.remove('nkc-selected');
        this._buttonContainer.querySelector(':not(.visually-hidden)')?.classList.add('nkc-selected');
    }
    up() {
        currentPage = new BrowsePageNavigation();
    }
    down() {
        document.querySelector('.nkc-selected')?.classList.remove('nkc-selected');
        currentPage = new BrowsePage();
        currentPage?.selectFirst();
    }
    next() {
        const currentSelected = this._buttonContainer?.querySelector('.nkc-selected');
        const next = currentSelected?.nextSibling;
        if (next) {
            currentSelected?.classList.remove('nkc-selected');
            next.classList.add('nkc-selected');
        }
    }
    previous() {
        const currentSelected = this._buttonContainer?.querySelector('.nkc-selected');
        const next = currentSelected?.previousSibling;
        if (next.classList.contains('visually-hidden'))
            return;
        currentSelected?.classList.remove('nkc-selected');
        next.classList.add('nkc-selected');
    }
    select() {
        console.log(document.querySelector('.nkc-selected'));
        document.querySelector('.nkc-selected')?.click();
    }
}
class StateManager {
    constructor() {
        this.pauseObserver = false;
        this.observer = new MutationObserver((mutations) => {
            this.handleMutations(mutations);
        });
        this.observer.observe(document.body, { subtree: true, childList: true });
    }
    set pauseObserver(value) {
        this._pauseObserver = value;
        if (value) {
            this.observer.disconnect();
        }
        else {
            this.observer = new MutationObserver((mutations) => {
                this.handleMutations(mutations);
            });
            this.observer.observe(document.body, { subtree: true, childList: true });
        }
    }
    get pauseObserver() {
        return this._pauseObserver;
    }
    handleMutations(mutations) {
        if (this.pauseObserver)
            return;
        if (location.href.includes('/title/')) {
            return;
        }
        for (const mutation of mutations) {
            if (this.pauseObserver) {
                break;
            }
            const target = mutation.target;
            if (currentPage && currentPage.handleMutation) {
                currentPage.handleMutation(mutation);
                return;
            }
            if (!document.querySelector('.nkc-selected')) {
                setCurrentPage();
            }
            if (target.querySelector(`.slider-item.slider-item-0`) && !document.querySelector('.nkc-selected')) {
                setCurrentPage();

                if (currentPage?.selectFirst)
                    currentPage?.selectFirst();
                return;
            }
            if (document.querySelector('li.profile') && !document.querySelector('.nkc-selected')) {
                setCurrentPage();
            }
        }
    }
}
const stateManager = new StateManager();
const body = document.querySelector('body');
var currentLocation;
var previousLocation = "https://www.netflix.com/browse";
class NavigationEvents {
    constructor() { }
    handleKeyPress(event) {
        // don't mess with the login page
        if (location.href.includes('/login'))
            return;

        const body = document.querySelector('body');
        // body.classList.add('pointer-none');
        const input = document.querySelector('.searchInput input');
        const selected = document.querySelector('.nkc-selected') || document.querySelector('.jawbone-selected');
        if (!selected || !currentPage) {
            setCurrentPage();
        }
        try {
            switch (event.key) {
                case 'BrowserBack':
                    if (location.href == "https://www.netflix.com/browse" && previousLocation == location.href)
                    {
                        let jsonObject = { Key: 'jrweb_back' };
                        window.chrome.webview.postMessage(jsonObject);
                    }
                    // This runs after the location was changed, so the above condition suppressed the change.
                    // On another press, either the location will change again and the variable be overriden, or we are at the beginning of history and want to exit
                    previousLocation = location.href;
                    break;
                case 'Backspace':
                    if (!input) {
                        if (location.href == "https://www.netflix.com/browse")
                        {
                            let jsonObject = { Key: 'jrweb_back' };
                            window.chrome.webview.postMessage(jsonObject);
                        } else
                            window.history.back();
                    }
                    break;
                case 'Escape':
                    if (!input) {
                        if (location.href == "https://www.netflix.com/browse")
                        {
                            let jsonObject = { Key: 'jrweb_back' };
                            window.chrome.webview.postMessage(jsonObject);
                        } else
                            window.location.href = "https://www.netflix.com/browse";
                    }
                    break;
                case 'f':
                case 'F':
                    if (event.shiftKey && !input) {
                        document.querySelector('.searchTab')?.click();
                        event.preventDefault();
                    }
                    break;
                case 'k':
                case 'K':
                    if (event.shiftKey && !input) {
                    }
                    break;
                case 's':
                case 'S':
                    if (event.shiftKey && !event.ctrlKey && !event.altKey && !input) {
                        window.location.href = 'https://www.netflix.com/profiles';
                    }
                    break;
                case 'ArrowRight':
                    currentPage.next();
                    break;
                case 'ArrowLeft':
                    if (event.altKey) {
                        window.history.back();
                    }
                    else {
                        currentPage.previous();
                    }
                    break;
                case 'ArrowUp':
                    event.preventDefault();
                    currentPage.up();
                    break;
                case 'ArrowDown':
                    event.preventDefault();
                    currentPage.down();
                    break;
                case 'Enter':
                    event.preventDefault();
                    event.cancelBubble = true;
                    currentPage.select();
                    break;
                default:
                    if (currentPage && currentPage.handleKeyPress)
                        currentPage.handleKeyPress(event);
                    break;
            }
        }
        catch (error) {
        }
    }
}

let getElementByXPath = function (xpath) {
  return document.evaluate(
    xpath, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null
  ).singleNodeValue;
};

function runSetMaxBitrate() {
    const VIDEO_SELECT = getElementByXPath("//div[text()='Video Bitrate']");
    const AUDIO_SELECT = getElementByXPath("//div[text()='Audio Bitrate']");
    const BUTTON = getElementByXPath("//button[text()='Override']");

    if (!BUTTON){
        window.dispatchEvent(new KeyboardEvent('keydown', {
            keyCode: 83,
            ctrlKey: true,
            altKey: true,
            shiftKey: true,
        }));
    }

    if (!(VIDEO_SELECT && AUDIO_SELECT && BUTTON)){
        return false;
    }

    [VIDEO_SELECT, AUDIO_SELECT].forEach(function (el) {
        let parent = el.parentElement;
        let options = parent.querySelectorAll('select > option');

        for (var i = 0; i < options.length - 1; i++) {
            options[i].removeAttribute('selected');
        }

        options[options.length - 1].setAttribute('selected', 'selected');
    });

    BUTTON.click();
    console.log("Bitrate change executed");

    return true;
}

let findBitrateButton = function (count) {
    const BUTTON = getElementByXPath("//button[text()='Override']");
    if (count > 0) {
        BUTTON ? runSetMaxBitrate() : setTimeout(() => findBitrateButton(count - 1), 200)
    }
};

let trySetMaxBitrate = function() {
    runSetMaxBitrate() ? findBitrateButton(10) : setTimeout(trySetMaxBitrate, 100);
}

function pageChanged()
{
    setCurrentPage();

    if (JR_setMaxBitrate && false) {
        const WATCH_REGEXP = /netflix.com\/watch\/.*/;
        WATCH_REGEXP.test(location.href) && trySetMaxBitrate();
    }
}

const navEvents = new NavigationEvents;
window.addEventListener('load', async () => {
    var styleSheet = document.createElement("style");
    styleSheet.type = "text/css";
    styleSheet.innerText = styles;
    document.head.appendChild(styleSheet);

    window.addEventListener("keydown", function (e) {
        JRLog("Keydown: " + e.key + " (" + e.keyCode + ") ctrl:" + e.ctrlKey + ", shift:" + e.shiftKey + ", alt:" + e.altKey);
        if ([37, 38, 39, 40].indexOf(e.keyCode) > -1) {
            e.preventDefault();
        }
        navEvents.handleKeyPress(e);
    }, false);
    window.addEventListener("keydown", function (e) {
        if (currentPage && currentPage.priorityKeyEvent) {
            currentPage.priorityKeyEvent(e);
        }
    }, true);
    let mouseTimer;
    pageChanged();
}, { once: true });

// catch URL changes
window.addEventListener('popstate', () => {
    window.dispatchEvent(new Event('locationchange'));
});

history.pushState = ( f => function pushState(){
    var ret = f.apply(this, arguments);
    window.dispatchEvent(new Event('locationchange'));
    return ret;
})(history.pushState);

history.replaceState = ( f => function replaceState(){
    var ret = f.apply(this, arguments);
    window.dispatchEvent(new Event('locationchange'));
    return ret;
})(history.replaceState);

window.addEventListener('locationchange', async () => {
    previousLocation = currentLocation;
    currentLocation = location.href;
    pageChanged();
});
try {
    window.chrome.webview.addEventListener('message', function (e) {
        if (currentPage && currentPage.handleMessage)
            currentPage.handleMessage(e);
    });
} catch (error) {}
